package de.meinefirma.meinprojekt.test;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.Arrays;

public class TestMultithreading
{
   // URL und insbesondere Portnummer anpassen:
   static final String SERVLET_URL      = "http://localhost:8080/JpaServlet/MeinTestServlet";
   static final String SERVLET_PARMNAME = "?text=";
   static final String SERVLET_POSTFIX  = "&r=threads";

   public static void main( String[] args )
   {
      int  threadCount = ( args.length > 0 ) ? Integer.parseInt( args[0] ) : 4;
      for( int i = 0; i < threadCount; i++ )
         (new Thread() {
            @Override public void run() {
               speichereUndLeseUeberServlet( Thread.currentThread().getName() );
            }
         }).start();
   }

   public static void speichereUndLeseUeberServlet( String text )
   {
      String servletUrl = SERVLET_URL + SERVLET_PARMNAME + text.replace( ' ', '+' ) + SERVLET_POSTFIX;
      System.out.println( "\nURL:  " + servletUrl + "\n" );
      long        tm = 0;
      int         lenTmp, lenAll = 0;
      InputStream is = null;
      try {
         URL url = new URL( servletUrl );
         is = url.openStream();
         byte[] buff = new byte[4096];
         tm = System.nanoTime();
         while( -1 != (lenTmp = is.read( buff )) ) {
           System.out.println( new String( Arrays.copyOfRange( buff, 0, lenTmp ) ) );
           lenAll += lenTmp;
         }
         tm = (System.nanoTime() - tm) / 1000000L;
      } catch( Exception ex ) {
         System.out.println( "\nError: " + ex );
      } finally {
         if( is != null ) try { is.close(); } catch( IOException ex ) {/*ok*/}
      }
      System.out.println( lenAll + " Bytes in " + tm + " ms\n" );
   }
}
